﻿// takes in a normal javascript array and returns an array consisting of Lava.Object
Lava.Array = function (array, object) {
    if (Lava.typeOf(array) == 'array') {
        var lavaArray = [];
        var arrayLen = array.length;

        for (var i = 0; i < arrayLen; i++) {
            var o = array[i];
            if (o.bindings) {
                // object is already a Lava.Object
                lavaArray.push(o);
            }
            else {
                var type = Lava.typeOf(o);

                if (type === 'array') {
                    // o is an array so we need to call createArray recursively
                    lavaArray.push(Lava.Array(o));
                }
                else if (type === 'object') {
                    // o is already an object so we just need to create a Lava.Object from it
                    if (object) {
                        lavaArray.push(object.clone(o));
                    }
                    else {
                        lavaArray.push(Lava.Object(o));
                    }
                }
                else {
                    // lava is not an array or object so we need to treat it as a single property
                    lavaArray.push(Lava.Object({ value: o }));
                }
            }
        }

        return lavaArray;
    }
    return null;
}
