﻿var routes = {};
var root = window.location.pathname;
var routingEnabled = false;

var cleanUpPath = function (route) {
    var routeLength = route.length;
    // remove trailing slash
    var route = (routeLength > 1 && route[routeLength - 1] === '/') ? route.substring(0, routeLength - 1) : route;
    // remove double slashes
    route = route.replace(/\/\//g, '');
    // remove trailing pound
    var route = (routeLength > 1 && route[routeLength - 1] === '#') ? route.substring(0, routeLength - 1) : route;
    return route;
};

Lava.Routes = {
    add: function (route, action) {
        if (!routingEnabled) {
            // set up the routing system
            window.onload = function (event) {
                initialRoute = window.location.hash.replace('#', '');
                Lava.Routes.go(initialRoute, true);
            };

            window.onpopstate = function (event) {
                if (event.state) {
                    Lava.Routes.go(event.state, true);
                }
            };

            window.onhashchange = function () {
                Lava.Routes.go(window.location.hash.replace('#', ''), true);
            };

            routingEnabled = true;
        }

        routes[route] = { name: route, path: cleanUpPath(root + '#' + route), action: action };
    },
    get: function (route) {
        return routes[route];
    },
    getCurrent: function () {
        return routes[window.location.hash.replace('#', '')];
    },
    go: function (route, ignorePushState) {
        var routeObj = routes[route];
        if (typeof routeObj == 'undefined') {
            return false;
        }
        if (!ignorePushState) {
            window.history.pushState(routeObj.name, routeObj.name, routeObj.path);
        }
        if (routeObj.action) {
            routeObj.action();
        }
    }
}
